unit Vraag3UMemo;
    //Oplossing vir vraag 3
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, ComCtrls, Menus;

type
  TfrmVR3 = class(TForm)
    mnuMain: TMainMenu;
    mnuOpsieA: TMenuItem;
    mnuOpsieB: TMenuItem;
    mnuOpsieC: TMenuItem;
    mnuVerlaat: TMenuItem;
    redV3: TRichEdit;
    procedure mnuOpsieAClick(Sender: TObject);
    procedure mnuVerlaatClick(Sender: TObject);
    procedure mnuOpsieBClick(Sender: TObject);
    procedure mnuOpsieCClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmVR3: TfrmVR3;

  arrTic : Array[1..32] of string = ('RCm158', 'ADM33', 'RCv250', 'RAv5',
  'BRM32', 'ADm236',  'RCm23', 'RDM54','RCv17', 'RAm12', 'ADm9', 'RCV43',
  'RDm140', 'RDm23', 'ACV113', 'ABv30', 'RDm22', 'ARv38', 'RCV8', 'RAv53',
  'RCv12', 'ABV156', 'ADM31', 'ADM47', 'RAv48', 'ABV246', 'ABv59', 'RRM321',
  'ABm36', 'RCV31', 'RAm445', 'ACn26');


implementation

{$R *.dfm}
{$R+}

uses Math;

var
  //arrays used in solution for Option C
  arrUitstal  : Array[1..8] of string =
                           ('AA','AB','AC','AD','RA','RB','RC','RD');
  arrPunte    : Array[1..8] of Integer = (0,0,0,0,0,0,0,0);
  arrMedalje  : Array[1..3] of string = ('Goud', 'Silwer', 'Brons');

procedure TfrmVR3.FormCreate(Sender: TObject);
begin
   Randomize;
end;

procedure TfrmVR3.mnuOpsieAClick(Sender: TObject);
var
  A : Integer;
begin
  redV3.Lines.Clear;
  redV3.Lines.Add('Ongeldige inskrywings:');
  For A := 1 to 32 do
   IF (arrTic[A][1] in ['A','R']) AND
      (arrTic[A][2] in ['A'..'D']) AND
      (Upcase(arrTic[a][3]) in ['M','V'])
     then //valid ticket  
     else
         begin //invalid ticket
            redV3.Lines.Add(arrTic[A]);
            arrTic[A] := 'Z';
         end;
end;

procedure TfrmVR3.mnuOpsieBClick(Sender: TObject);
var
  iKaartjie  :integer;
  bGeldig   :boolean;
begin
 bGeldig := false;
 iKaartjie := random(32) + 1;
 while (bGeldig = false) do
  begin
    if arrTic[iKaartjie] = 'Z' then
    begin
       bGeldig := false ;
       redV3.Lines.Add('Ongeldig');
       iKaartjie := random(32) + 1;
    end
    else
       bGeldig := true;
  end;
  redV3.Lines.Add('Die posisie van die wenkaartjie in die skikking is: ' +
                       intToStr(iKaartjie));
  redV3.Lines.Add('Die wenkaartjie: '+ arrTic[iKaartjie] );
end;

procedure TfrmVR3.mnuOpsieCClick(Sender: TObject);
var
   A, D, iPunt, iTemp  : Integer;
   sTemp                : string;
begin
  //Vir elke uitstalling bereken die punte.
  for D := 1 to 8 do
     arrPunte[D] := 0;

  for D := 1 to 8 do
   begin
     For A := 1 to 32 do
      begin
        IF pos(arrUitstal[D], arrTic[A]) = 1 //only valid tickets <> Z
         then
          begin
             case arrTic[A][3] of
              'm', 'v' : iPunt := 5;
              'M', 'V' : iPunt := 12;
             end;
             inc(arrPunte[D], iPunt);
          end;
      end; //for A.
   end; //for D.
 
  //Sorteer skikkings volgends die punte >> ENIGE SORTEER METODE!
  For A := 1 to 8-1 do
    For D := a+1 to 8 do
     IF arrPunte[A] < arrPunte[D]
      then
       begin //ruil elemente van beide skikkings om
         sTemp            := arrUitstal[D];
         arrUitstal[D]    := arrUitstal[A];
         arrUitstal[A]    := sTemp;

         iTemp           := arrPunte[D];
         arrPunte[D]     := arrPunte[A];
         arrPunte[A]     := iTemp;
       end;

  //Vertoon uitslae
  redV3.Lines.Clear;
  redV3.Paragraph.TabCount := 2;
  redV3.Paragraph.Tab[0]   := 80;
  redV3.Paragraph.Tab[1]   := 200;
  redV3.Lines.Add('Uitstallings wat medaljes wen:');
  redV3.Lines.Add('Medalje' + #9 + 'Uitstalling' + #9 + 'Punte');
  for A := 1 to 3 do
    redV3.Lines.Add(arrMedalje[A] +#9+ arrUitstal[A] +#9+ IntToStr(arrPunte[A]));
end;

procedure TfrmVR3.mnuVerlaatClick(Sender: TObject);
begin
     Application.Terminate;
end;

end.
