unit Vraag1UMemo;
   //Oplossing vir Vraag 1 ...
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DB, ADODB, Grids, DBGrids, ExtCtrls, Buttons, Menus;

type
  TfrmVraagEEN = class(TForm)
    qryRec: TADOQuery;
    dsrQry: TDataSource;
    grdRec: TDBGrid;
    mnuMain: TMainMenu;
    mnuOpsieA: TMenuItem;
    mnuOpsieB: TMenuItem;
    mnuOpsieC: TMenuItem;
    mnuOpsieD: TMenuItem;
    mnuOpsieE: TMenuItem;
    mnuOpsieF: TMenuItem;
    mnuOpsieG: TMenuItem;
    mnuVerlaat: TMenuItem;
    procedure mnuOpsieAClick(Sender: TObject);
    procedure mnuOpsieBClick(Sender: TObject);
    procedure mnuOpsieCClick(Sender: TObject);
    procedure mnuOpsieDClick(Sender: TObject);
    procedure mnuOpsieEClick(Sender: TObject);
    procedure mnuOpsieFClick(Sender: TObject);
    procedure mnuOpsieGClick(Sender: TObject);
    procedure mnuVerlaatClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmVraagEEN: TfrmVraagEEN;

implementation

{$R *.dfm}

procedure TfrmVraagEEN.mnuOpsieAClick(Sender: TObject);
begin
  qryRec.Close;
  qryRec.SQL.Text :=  'SELECT * FROM tblKarnivore ORDER BY FamilieNaam, WetenskaplikeNaam';
  qryRec.Open;                  
end;
//=========================================================================================
procedure TfrmVraagEEN.mnuOpsieBClick(Sender: TObject);
var
   sX : String;
begin
  sX := INPUTBOX('Vraag 1', 'Sleutel Familienaam in.', 'Canidae');
  qryRec.Close;
  qryRec.SQL.Text :=  'SELECT WetenskaplikeNaam, AlgemeneNaam, KampNr, KampGrootte ' +
                      'FROM tblKarnivore ' +
                      'WHERE (FamilieNaam LIKE "%' +sX + '%") AND (KampNr LIKE "ZE%")';
  qryRec.Open;
end;
//=========================================================================================
procedure TfrmVraagEEN.mnuOpsieCClick(Sender: TObject);
begin
  qryRec.Close;
  qryRec.SQL.Text :=  'SELECT Bedreigd, COUNT(TelVolwassenes+TelKleintjies) AS TelDiere ' +
                      'FROM tblKarnivore ' +
                      'GROUP BY Bedreigd';
  qryRec.Open;
end;
//=========================================================================================
procedure TfrmVraagEEN.mnuOpsieDClick(Sender: TObject);
begin
  qryRec.Close;
  qryRec.SQL.Text :=  'SELECT KampNr, FORMAT((KampGrootte/(TelVolwassenes+TelKleintjies)),"#.00") AS SpasiePerDier ' +
                      'FROM tblKarnivore ' +
                      'WHERE AlgemeneNaam LIKE "%muishond%" ';
  qryRec.Open;
end;
//=========================================================================================
procedure TfrmVraagEEN.mnuOpsieEClick(Sender: TObject);
begin
  qryRec.Close;
  qryRec.SQL.Text :=  'UPDATE tblKarnivore ' +
                      'SET TelKleintjies = TelKleintjies + 3 ' +
                      'WHERE KampNr="ZF1"';
  qryRec.ExecSQL;
  MessageDlg('Rekords suksesvol verwerk',mtInformation,[mbok],0);
end;
//=========================================================================================
procedure TfrmVraagEEN.mnuOpsieFClick(Sender: TObject);
var
   sX : String;
begin
  sX := INPUTBOX('Vraag 1', 'Sleutel die dag van die maand waarin besoek plaasvind in.', '23');
  qryRec.Close;
  qryRec.SQL.Text :=  'SELECT K.KampNr, AlgemeneNaam, BesoekDatum, RedeVirBesoek, Dier_ID ' +
                      'FROM tblKarnivore K, tblVeeartsBesoeke V ' +
                      'WHERE (DAY(BesoekDatum)='+sX+') AND K.KampNr = V.KampNr';
  qryRec.Open;
end;
//=========================================================================================
procedure TfrmVraagEEN.mnuOpsieGClick(Sender: TObject);
begin
  qryRec.Close;
  qryRec.SQL.Text :=  'INSERT INTO tblVeeartsBesoeke ' +
                      '(BesoekDatum, KampNr, RedeVirBesoek, Opvolg, Dier_ID) ' +
                      'VALUES (#2012/10/25#, "ZD5", "Oorinfeksie", True, "ZD5_3")';
  qryRec.ExecSQL;
  MessageDlg('Rekords suksesvol verwerk',mtInformation,[mbok],0);
end;
//=========================================================================================
procedure TfrmVraagEEN.mnuVerlaatClick(Sender: TObject);
begin
   Application.Terminate;
end;

end.
